<template>
    <div>
        <div class="loading" v-if="loading">
            <p id="loadd">LOADING...</p>
        </div>
        <div id="modalCentre" class="modal">
            <div class="modal-content">
                <div class="loading" v-if="loading">
                    <p id="loadd">LOADING...</p>
                </div>
                <h3>Selecciona el centre</h3>
                <div>
                    <label id="clientL">Client:</label>
                    <input list="clientsL" id="clients" style="text-transform:uppercase" name="clients" v-on:click="deleteValue('clients')" v-on:input="getCentres()" required >
                    <datalist id="clientsL"></datalist>
                </div>
                <div>
                    <label id="centreL">Centre:</label>
                    <input list="centresL" id="centres" name="centres" style="text-transform:uppercase" v-on:click="deleteValue('centres')" disabled required >
                    <datalist id="centresL"></datalist>
                </div>
                <button class="btn btn-primary btn-v" id="btn-validar" type="submit" v-on:click="tancarModal()">
                    <span class="glyphicon glyphicon-plus"></span> Validar
                </button>
            </div>
        </div>
        <div id="modalTasca" class="modal">
            <div class="modal-content">
                <div class="loading" v-if="loading">
                    <p id="loadd">LOADING...</p>
                </div>
                <button class="btn" id="close" type="submit" v-on:click="obrirModal('tancar')">
                    <span class="close">&times;</span>
                </button>
                <h3>Adhesió de les tasques</h3>
                <div>
                    <label>Treballador: {{ nomTreballador }}</label>
                </div>
                <div>
                    <span id="sumaHores"></span>
                </div>
                <div>
                    <table id="tNTasques">
                        <tr>
                            <td class="campT">
                                <b>Tasca</b>
                            </td>
                            <td>
                                <b>Temps</b>
                            </td>
                            <td>
                                <b>Quantitat</b>
                            </td>
                        </tr>
                        <tr v-for="tasca in tasquesTre" v-bind:key="tasca.id">
                            <td class="campT" :id="tasca.id">
                                <input list="tasquesTaula" :value="tasca.concepte_id"/>
                            </td>
                            
                            <td>
                                <input type="time" step="1" :value="tasca.tempsRealTotal" v-on:input="restaHores()"/>
                            </td>
                            <td>
                                <input type="number" :value="tasca.unitats"/>
                            </td>
                        </tr>
                    </table>
                    <div id="btn-modal-tasca">
                        <button class="btn btn-success" type="submit" v-on:click="actualitzarPrimerRegistre(idTreballador)" >
                            Guardar
                        </button>
                        <button class="btn btn-primary" type="submit" v-on:click="afegirLinia()">
                            <span class="glyphicon glyphicon-plus"></span> Afegir línia
                        </button>
                        <button class="btn btn-danger" type="submit" v-on:click="eliminarLinia()">
                            <span class="glyphicon glyphicon-minus"></span> Eliminar última línia
                        </button>
                    </div>
                </div>
            </div>
        </div>
        <div id="item-P">
            <label id="dataL">Dia:</label>
            <input type="date" class="dataS" id="dataDia" v-model="dataR" v-on:input="getData()" required>
        </div>
        <div>
            <label id="clientL">Client: {{ clientE }}</label>
        </div>
        <div>
            <label id="centreL">Centre: {{ centreE }}</label>
        </div>
        <div class="container">
            <div class="card mostrarTasca">
                <div class="card-header">Afegir tasca</div>
                <div class="card-body">
                    <table id="tTasques">
                        <tr>
                            <td class="campT">
                                <b>Nom del treballador/a</b>
                            </td>

                            <td class="campT">
                                <b>Tasca assignada</b>
                            </td>

                            <td class="campT">
                                <b>Temps tardat</b>
                            </td>

                            <td class="campT">
                                <b>Unitats</b>
                            </td>

                            <td class="campT">
                                <b>Afegir tasques</b>
                            </td>
                        </tr>
                        <datalist id="tasquesTaula"></datalist>
                        <tr v-for="(treballador, index) in treballadorsTaula" v-bind:key="treballador.id">
                            <td class="campT" v-text="treballador.treballador_id"></td>
                            <td class="campT">
                                <input list="tasquesTaula" id="tasquesSTaula" name="tasques" v-on:input="updateFeina(index, treballador.id)" :value="treballador.concepte_id" required/>
                            </td>
                            <td class="campT" >
                                <input type="time" step="1" id="tempsTaula" :value="treballador.tempsRealTotal">
                            </td>
                            <td class="campT">
                                <input type="number" id="quantTaula" :value="treballador.unitats" placeholder='Quantitat...' />
                            </td>
                            <td class="campT">
                                <button class="btn btn-primary" id="myBtn" type="submit" v-on:click="obrirModal('obrir', treballador.id)">
                                    <span class="glyphicon glyphicon-plus"></span>
                                </button>
                            </td>
                        </tr>
                    </table>
                    <button class="btn btn-primary btn-v" id="btn-validar" type="submit" v-on:click="validarConceptes()">
                        <span class="glyphicon glyphicon-plus"></span> Validar
                    </button>
                </div>
            </div>
        </div>
    </div>
</template>

<script>
export default {
    props: ["user", "rutaaction", "ruta"],
    mounted() {
        console.log("Component mounted.");
    },
    data: function() {
        return {
            //Id centre i client guardats a la bbdd
            centreClientG: null,
            //variable que controla quan disparar el loading
            loading: false,
            //Llistat clients obtinguts per l'API
            clientsL: [],
            //Llistat centres obtinguts per l'API
            clientsL: [],
            //Variable que guarda la data seleccionada, en cas de ser null serà la data d'avui
            dataR: null,
            //Llistat de totes les tasques guardades a la bbdd
            totesTasques: [],
            //Llistat de les tasques assignades al centre
            tasquesC: null,
            //Llistar tots els treballadors
            treballadorsT: [],
            //Treballadors que han fitchat avui
            treballadorsF: [],
            //Tots els treballadors
            treballadorN: null,
            //Llistat concepte assignats al centre
            tasquesC: [],
            //Objecte que conte la hora d'inici i final del treballador + id
            horariFitxar: null,
            //Temps que ha estat treballanat cada treballador
            horesFetes: null,
            //LListat dels treballadors que han fitxar per entrar i sortir de la data corresponent.
            treballadorsTaula: [],
            //Nom treballador al afegir tasques
            nomTreballador: null,
            //Id treballador
            idTreballador: null,
            //id tascaTreballador
            idFeinaTreballador: null,
            //Llistat feines per id treballador
            tasquesTre: [],
            //Objecte client
            clientObj: null,
            //Object centre
            centreObj: null,
            //nom centre
            centreE: null,
            //nom client
            clientE: null,
            tascaV: null,
            tempsV: null,
            unitatsV: null,
        };
    },
    methods: {
        updateFeina($index, $idT){
            var tascaSeleccionada;
            var tasquesNomID;
            var id = $index + 1;
            var table = document.getElementById("tTasques");
            var tascaS = table.rows[id].cells[1].getElementsByTagName('input')[0].value;
            var tempsS = table.rows[id].cells[2].getElementsByTagName('input')[0].value;
            var unitatsS = table.rows[id].cells[3].getElementsByTagName('input')[0].value;
            axios
            .get(this.ruta + '/api/conceptebyid/' + $idT)
            .then(response => {
                tascaSeleccionada = response.data;
                var res = tascaS.replace(/ /g, "-");
                axios
                .get(this.ruta + '/api/comprovarTasca/' + res)
                .then(response => {
                    tasquesNomID = response.data;

                    axios
                    .post(this.ruta + '/api/actualitzarfila/' + $idT, {
                        client_id: this.clientObj.id,
                        centre_id: this.centreObj.id,
                        treballador_id: tascaSeleccionada.treballador_id,
                        concepte_id: this.tasquesT[j].id, 
                        data: this.dataR,
                        unitats: cellQuant, 
                        tempsRealTotal: cellTemps, 
                        actiu: 0
                    });
                });
            });
        },
        getClients() {
            var clientsLL = document.getElementById("clientsL");
            var text = "";
            axios.get(this.ruta + "/api/clientsL").then(response => {
                this.clientsL = response.data;
                for (let i = 0; i < this.clientsL.length; i++) {
                    text += '<option value="' + this.clientsL[i].nomClient + '">';
                }
                clientsLL.innerHTML = text;
                text = "";
            }).finally(() => this.loading = false);
        },
        getCentres() {
            this.loading = true;
            var client = document.getElementById("clients").value;
            var centresLL = document.getElementById("centresL");
            document.getElementById("centres").disabled = false;
            var text = "";
            var sortir = false;
            var i = 0;
            while (i < this.clientsL.length && sortir == false) {
                if (this.clientsL[i].nomClient == client) {
                    sortir = true;
                } else {
                    i++;
                }
            }
            if (sortir == true) {
                this.idClient = this.clientsL[i].id;
                axios
                .get(this.ruta + "/api/centresbyidclient/" + this.clientsL[i].id)
                .then(response => {
                    this.centresL = response.data;
                    for (let i = 0; i < this.centresL.length; i++) {
                        text += '<option value="' + this.centresL[i].nomCentre + '">';
                    }
                    centresLL.innerHTML = text;
                    text = "";
                }).finally(() => this.loading = false);
            }
        },
        tancarModal(){
            this.loading = true;
            var client = document.getElementById("clients");
            var centre = document.getElementById("centres");
            var centre_id;
            var client_id;
            var sortir = false;
            var i = 0;
            var j = 0;

            while(j < this.clientsL.length && sortir == false){
                if(client.value == this.clientsL[j].nomClient){
                    sortir = true;
                    client_id = this.clientsL[j].id;
                }else{
                    j++;
                }
            }
            sortir = false;
            while(i < this.centresL.length && sortir == false){
                if(centre.value == this.centresL[i].nomCentre){
                    sortir = true;
                    centre_id = this.centresL[i].id;
                }else{
                    i++;
                }
            }
            if(sortir == true){
                axios
                .post(this.ruta + "/api/guardarcentreclient", {
                    user_id: this.user,
                    client_id: client_id,
                    centre_id: centre_id
                })
                .then(response =>{

                });
                document.getElementById("modalCentre").style.display = "none";
                this.obtenirCentreClient();
                this.centreE = centre.value;
                this.clientE = client.value;
            }
        },
        obtenirCentreClient(){
            axios
            .get(this.ruta + '/api/obtenircentreclient/' + this.user)
            .then(response => {
                this.centreClientG = response.data;
            })
            .then(response => {
                axios
                .get(this.ruta + '/api/clientbyid/' + this.centreClientG.client_id)
                .then(response => {
                    this.clientObj = response.data;
                });

                axios
                .get(this.ruta + '/api/centrebyid/' + this.centreClientG.centre_id)
                .then(response => {
                    this.centreObj = response.data;
                });
                this.getData();
            })
        },
        deleteValue($inputC) {
            if($inputC == 'clients'){
                document.getElementById($inputC).value = "";
                document.getElementById('centresL').innerHTML = "";
                document.getElementById('centres').value = "";
                document.getElementById('centres').disabled = true;
            }else if($inputC == 'centres'){
                document.getElementById($inputC).value = "";
            }
        },
        getData() {
            this.loading = true;
            this.getDataDia();
            this.getLlistar();
        },
        getDataDia() {
            var dataA = this.dataR;
            if (dataA == "" || dataA == null) {
                var d = new Date();
                var curr_date = d.getDate();
                var curr_month = d.getMonth() + 1;
                var curr_year = d.getFullYear();
                if (curr_month < 10) {
                    curr_month = "0" + curr_month;
                }
                if (curr_date < 10) {
                    curr_date = "0" + curr_date;
                }
                dataA = curr_year + "-" + curr_month + "-" + curr_date;
                this.dataR = dataA;
            }
        },
        getLlistar() {
            this.llistarTreballadorsF();
            this.getTasques();
        },
        getTasques() {
            var tasquesTaula = document.getElementById("tasquesTaula");
            var sortir = false;
            var j = 0;
            var text = "";
            
            axios
            .get(this.ruta + '/api/conceptescentre/' + this.centreClientG.client_id + '-' + this.centreClientG.centre_id)
            .then(response => {
                this.tasquesC = response.data;
                axios
                .get(this.ruta + '/api/tasques')
                .then(response => {
                    this.tasquesT = response.data;
                    for (let i = 0; i < this.tasquesC.length; i++) {
                        while(j < this.tasquesT.length && sortir == false){
                            if(this.tasquesC[i].concepte_id == this.tasquesT[j].id){
                                sortir = true;
                            }else{
                                j++;
                            }
                        }

                        if(sortir == true){
                            text += '<option value="' + this.tasquesT[j].nomTasca + '">';
                        }
                        j = 0;
                        sortir = false;
                    }
                    tasquesTaula.innerHTML = text;
                    text = "";
                }).finally(() => this.loading = false)
            })
        },
        llistarTreballadorsF() {
            axios
            .get(this.ruta + '/api/treballadorsF/' + this.centreClientG.client_id + '-' + this.centreClientG.centre_id + '-' + this.dataR)
            .then(response => {
                this.treballadorsTaula = response.data;
                for (let i = 0; i < this.treballadorsTaula.length; i++) {
                    axios
                    .get(this.ruta + '/api/tasques')
                    .then(response => {
                        this.tasquesT = response.data;
                        var sortir = false;
                        var j = 0;
                        while(j < this.tasquesT.length && sortir == false){
                            if(this.treballadorsTaula[i].concepte_id == this.tasquesT[j].id){
                                sortir = true;
                            }else{
                                j++;
                            }
                        }
                        if(sortir == true){
                            this.treballadorsTaula[i].concepte_id = this.tasquesT[j].nomTasca;
                        }
                    }).catch(function (error) {
                        console.log(error);
                        alert('Error descarregant dades, torna a provar-ho');
                    });
                    
                    axios
                    .get(this.ruta + '/api/treballadors')
                    .then(response => {
                        this.treballadorsT = response.data;
                        var sortir = false;
                        var j = 0;
                        var $id = this.treballadorsTaula[i].client_id + '-' + this.treballadorsTaula[i].centre_id + '-' + this.treballadorsTaula[i].treballador_id + '-' + this.dataR;
                        this.getHorestreballades($id, i);
                        while(j < this.treballadorsT.length && sortir == false){
                            if(this.treballadorsTaula[i].treballador_id == this.treballadorsT[j].id){
                                sortir = true;
                            }else{
                                j++;
                            }
                        }
                        if(sortir == true){
                            this.treballadorsTaula[i].treballador_id = this.treballadorsT[j].nom;
                        }
                        sortir = false;
                        j = 0;
                    }).catch(function (error) {
                        console.log(error);
                        alert('Error descarregant dades, torna a provar-ho');
                    });
                }
            }).catch(function (error) {
                console.log(error);
                alert('Error descarregant prova, dades a provar-ho');
            });
        },
        getHorestreballades($id, i){
            axios
            .get(this.ruta + '/api/obtenirhoresfitxar/' + $id)
            .then(response => {
                this.horesFetes = response.data;
                var tt = this.treballadorsTaula[i].tempsRealTotal;
                this.treballadorsTaula[i].tempsRealTotal = this.horesFetes;
                this.treballadorsTaula[i].tempsRealTotal = tt;
            });
        },
        obrirModal($obrir, $id){
            this.loading = true;
            var modal = document.getElementById("modalTasca");
            if($obrir == 'obrir'){
                modal.style.display = "block";
                var ids;
                var treballador;
                axios
                .get(this.ruta + '/api/conceptebyid/' + $id)
                .then(response => {
                    ids = response.data;
                    axios
                    .get(this.ruta + '/api/treballadorById/' + ids.treballador_id)
                    .then(response => {
                        treballador = response.data;
                        this.nomTreballador = treballador.nom;
                        this.idTreballador = treballador.id;
                        axios
                        .get(this.ruta + '/api/mostrarconceptestreballador/' + this.clientObj.id + '-' + this.centreObj.id + '-' + this.idTreballador + '-' + this.dataR)
                        .then(response => {
                            this.tasquesTre = response.data;
                            axios
                            .get(this.ruta + '/api/tasques')
                            .then(response => {
                                this.totesTasques = response.data;
                                var sortir = false;
                                var j = 0;
                                for (let i = 0; i < this.tasquesTre.length; i++) {
                                    while(j < this.totesTasques.length && sortir == false){
                                        if(this.tasquesTre[i].concepte_id == this.totesTasques[j].id){
                                            sortir = true;
                                        }else{
                                            j++;
                                        }
                                    }

                                    if(sortir == true){
                                        this.tasquesTre[i].concepte_id = this.totesTasques[j].nomTasca;
                                    }else{
                                        this.tasquesTre[i].concepte_id = document.getElementById("tasquesSTaula").value;
                                    }

                                    sortir = false;
                                    j = 0;
                                }
                            }).finally(() => this.loading = false);
                        });
                    });
                });
            }else{
                modal.style.display = "none";
                var table = document.getElementById("tNTasques");
                var x = document.getElementById("tNTasques").rows.length;
                var a;
                x = x-1;
                for (let i = x; i > 0; i--) {
                    a = document.getElementById("tNTasques").rows[i].cells[0].id;
                    if(a == ""){
                        table.deleteRow(i); 
                    } 
                }
                this.getData();
            }
        },
        afegirLinia(){
            var table = document.getElementById("tNTasques");
            var x = document.getElementById("tNTasques").rows.length;
            var row = table.insertRow(x);
            var cell1 = row.insertCell(0);
            var cell2 = row.insertCell(1);
            var cell3 = row.insertCell(2);
            var tasca = document.createElement("INPUT");
            var temps = document.createElement("INPUT");
            var quantitat = document.createElement("INPUT");
            tasca.setAttribute("list", "tasquesTaula");
            temps.setAttribute("type", "time");
            temps.setAttribute("step", "1");
            temps.setAttribute("v-on:input", "restaHores()");
            temps.value = "00:00:00";
            quantitat.setAttribute("type", "number");
            
            cell1.appendChild(tasca);
            cell2.appendChild(temps);
            cell3.appendChild(quantitat);
        },
        eliminarLinia(){
            var table = document.getElementById("tNTasques");
            var x = document.getElementById("tNTasques").rows.length;
            if(x-1 > 1){
                table.deleteRow(x-1);
            }
        },
        actualitzarPrimerRegistre($id){
            var table = document.getElementById("tNTasques");
            var x = document.getElementById("tNTasques").rows.length;

            var table = document.getElementById("tNTasques");
            var x = document.getElementById("tNTasques").rows.length;
            var cont = 0;
            if(document.getElementById("sumaHores").innerHTML != '00:00:00'){
                for (let i = 1; i < x; i++) {
                    if(table.rows[i].cells[1].getElementsByTagName('input')[0].value == '00:00:00'){
                        cont++;
                    }
                }
                var hora = document.getElementById("sumaHores").innerHTML;
                var hores = hora.split(":");
                var suma = 0;
                var suma = (parseInt(hores[0]) * 3600) + (parseInt(hores[1]) * 60) + (parseInt(hores[2]));
                var totalMin = suma / cont;
                var residu2 = suma % cont;
                var divisio = totalMin;
                var txtHora;
                var residu;

                for (let i = 0; i < 3; i++) {
                    residu = divisio;
                    divisio = divisio / 60;
                    divisio = Math.trunc(divisio);
                    residu = residu % 60;
                    if(i == 0){
                        if(residu < 10){
                            txtHora = '0' + residu;
                        }else{
                            txtHora = residu;
                        }
                    }else{
                        if(residu < 10){
                            txtHora = '0' + residu + ':' + txtHora;
                        }else{
                            txtHora = residu + ':' + txtHora
                        }
                    }
                }
            }
            var a;
            var j = 0;
            var sortir = false;
            for (let i = 1; i < x; i++) {
                var cellTasca = table.rows[i].cells[0].getElementsByTagName('input')[0].value;
                var cellTemps = table.rows[i].cells[1].getElementsByTagName('input')[0].value;
                if(cellTemps == '00:00:00'){
                    cellTemps = txtHora;
                }
                var cellQuant = table.rows[i].cells[2].getElementsByTagName('input')[0].value;
                a = table.rows[i].cells[0].id;
                while(j < this.tasquesT.length && sortir == false){
                    if(this.tasquesT[j].nomTasca == cellTasca){
                        sortir = true;
                    }else{
                        j++;
                    }
                }
                if(sortir == true){
                    axios
                    .post(this.ruta + '/api/actualitzarfila/' + a, {
                        client_id: this.clientObj.id,
                        centre_id: this.centreObj.id,
                        treballador_id: $id,
                        concepte_id: this.tasquesT[j].id, 
                        data: this.dataR,
                        unitats: cellQuant, 
                        tempsRealTotal: cellTemps, 
                        actiu: 0
                    })
                    .then(response =>{

                    })
                }
            }
            this.obrirModal('tancar');
        },
        repartirHores(){
            var table = document.getElementById("tNTasques");
            var x = document.getElementById("tNTasques").rows.length;
            var cont = 0;
            if(document.getElementById("sumaHores").innerHTML != '00:00:00'){
                for (let i = 1; i < x; i++) {
                    if(table.rows[i].cells[1].getElementsByTagName('input')[0].value == '00:00:00'){
                        cont++;
                    }
                }

                var hora = document.getElementById("sumaHores").innerHTML;
                var hores = hora.split(":");
                var suma = suma + (parseInt(hora[0]) * 3600) + (parseInt(hora[1]) * 60) + (parseInt(hora[2]));
                var totalMin = suma / cont;
                var residu2 = suma % cont;
                var divisio = totalMin;

                for (let i = 0; i < 3; i++) {
                    residu = divisio;
                    divisio = divisio / 60;
                    divisio = Math.trunc(divisio);
                    residu = residu % 60;
                    if(i == 0){
                        if(residu < 10){
                            txtHora = '0' + residu;
                        }else{
                            txtHora = residu;
                        }
                    }else{
                        if(residu < 10){
                            txtHora = '0' + residu + ':' + txtHora;
                        }else{
                            txtHora = residu + ':' + txtHora
                        }
                    }
                }
            }
        },
        restaHores(){
            var table = document.getElementById("tNTasques");
            var x = document.getElementById("tNTasques").rows.length;
            var horesSumades = this.horesFetes;
            var temps;
            var hora;
            var txtHora;
            var suma = 0;
            var total = 0;
            var divisio = 0;
            var residu = 0;

            for (let i = 1; i < x; i++) {
                temps = table.rows[i].cells[1].getElementsByTagName('input')[0].value;
                hora = temps.split(':');
                if(hora.length == 3){
                    suma = suma + (parseInt(hora[0]) * 3600) + (parseInt(hora[1]) * 60) + (parseInt(hora[2]));
                }else{
                    suma = suma + (parseInt(hora[0]) * 3600) + (parseInt(hora[1]) * 60);
                }
            }

            hora = horesSumades.split(':');
            if(hora.length == 3){
                total = (parseInt(hora[0]) * 3600) + (parseInt(hora[1]) * 60) + (parseInt(hora[2]));
            }else{
                total = (parseInt(hora[0]) * 3600) + (parseInt(hora[1]) * 60);
            }

            total = total - suma;

            if(total < 0){
                 document.getElementById("sumaHores").innerHTML = "00:00:00"
            }else{
                divisio = total;
                for (let i = 0; i < 3; i++) {
                    residu = divisio;
                    divisio = divisio / 60;
                    divisio = Math.trunc(divisio);
                    residu = residu % 60;
                    if(i == 0){
                        if(residu < 10){
                            txtHora = '0' + residu;
                        }else{
                            txtHora = residu;
                        }
                    }else{
                        if(residu < 10){
                            txtHora = '0' + residu + ':' + txtHora;
                        }else{
                            txtHora = residu + ':' + txtHora
                        }
                    }
                }
                document.getElementById("sumaHores").innerHTML = txtHora;
            }
            this.loading = false;
            
        }
    },
    mounted: function() {
        console.log("Component mounted.");
        this.loading = true;
        axios
        .get(this.ruta + '/api/obtenircentreclient/' + this.user)
        .then(response => {
            this.centreClientG = response.data;
            if(typeof(this.centreClientG.centre_id) == 'undefined'){
                document.getElementById("modalCentre").style.display = "block";
                this.getClients();
            }else{
                axios
                .get(this.ruta + '/api/clientbyid/' + this.centreClientG.client_id)
                .then(response => {
                    this.clientObj = response.data;
                    this.clientE = this.clientObj.nomClient;
                });

                axios
                .get(this.ruta + '/api/centrebyid/' + this.centreClientG.centre_id)
                .then(response => {
                    this.centreObj = response.data;
                    this.centreE = this.centreObj.nomCentre;
                });
                this.getData();
            }
        });
    }
};
</script>
